{$M 65520, 0, 655360}
program lavirint;

uses crt;

const
	maxtran = 4;
        maxw = 80; maxh = 25;

type
	mali = -1..1;
        povecanje = record
        	x, y: mali;
        end;

{ Global variables }

var
	tran: array[1..maxtran] of povecanje;
        tabla: array[1..maxw, 1..maxh] of integer;
        startx, starty, ciljx, ciljy, maxi, maxj: integer;
        w: set of 1..maxw;
        h: set of 1..maxh;
        anim: boolean;
        pauza: integer;

{ System-dependant functions }

procedure drawxy(x, y: integer);
begin
	if (x in w) and (y in h) then
        begin
        	gotoxy(x, y);
                if tabla[x, y] = -2 then write('.')      {bivsi put}
                else if tabla[x, y] < 0 then write('o')  {put}
                else if tabla[x, y] = 0 then write('.')  {hodnik}
                else if tabla[x, y] > 0 then write('#'); {zid}
                if anim then delay(pauza)
        end
end;

procedure error(msg: string);
begin
	writeln('lavirint: ', msg);
        halt(1)
end;

{ General functions }

function slobodno(x, y: integer; var x1, y1: integer): boolean;
var ret: boolean; i: integer;
begin
	i := 1; ret := false;
	repeat
        	x1 := x + tran[i].x; y1 := y + tran[i].y;
                if (x1 in w) and (y1 in h) then
                	if tabla[x1, y1] = 0 then
                        	ret := true;
        	i := i + 1
        until (i > maxtran) or ret;
        slobodno := ret;
end;

{ -1 = false    }
{  0 = Nadjeno! }
{  1 = true     }
function probaj(x, y: integer): mali;
var ret: mali; x1, y1, j: integer;
begin
	ret := 1; tabla[x, y] := -1; drawxy(x, y);
        if (x = ciljx) and (y = ciljy) then ret := 0
        else begin
        	j := 1;
        	while (j <= maxtran) and (ret <> 0) do
        	begin
        		if slobodno(x, y, x1, y1) then begin
				ret := probaj(x1, y1)
                        end
                	else if j = maxtran then ret := -1;
                	j := j + 1
        	end
        end;
        if ret = -1 then begin
        	tabla[x, y] := -2; drawxy(x, y)
        end;
        probaj := ret
end;

{ Main program variables }

var
	i, j: integer;
        f: text;

begin
	anim := false;
	w := [1..maxw]; h := [1..maxh];
	tran[1].x :=  0; tran[1].y := -1;
	tran[2].x :=  1; tran[2].y :=  0;
	tran[3].x :=  0; tran[3].y :=  1;
	tran[4].x := -1; tran[4].y :=  0;

        for i := 1 to maxw do
        	for j := 1 to maxh do
                	tabla[i, j] := 0;

        assign(f, 'lavirint.dat');
        {$I-}
        reset(f);
        {$I+}
        if IOResult <> 0 then error('Ne mogu da otvorim fajl!');
        readln(f, startx, starty); readln(f, ciljx, ciljy);
	j := 1;
        while not eof(f) and (j in h) do
        begin
        	i := 1;
        	while not eoln(f) and (i in w) do
                begin
        		read(f, tabla[i, j]);
                        i := i + 1
                end;
                readln(f); j := j + 1
        end;
        close(f);

        maxi := i-1; maxj := j-1;
        w := [1..maxi]; h := [1..maxj];

        if ([startx, ciljx] * w <> [startx, ciljx])
		or ([starty, ciljy] * h <> [starty, ciljy])
		or (tabla[startx, starty] <> 0)
		or (tabla[ciljx, ciljy] <> 0) then
        	error('Prekoracenje!');

        write('Unesite pauzu, u msec: '); readln(pauza);

	clrscr;
        for i := 1 to maxi do
        	for j := 1 to maxj do
                	drawxy(i, j);

        tabla[startx, starty] := 1;

        anim := true;
        if probaj(startx, starty) = 0 then begin
		gotoxy(23, maxj div 2); write(' LAVIRINT JE RESIV! ')
        end else begin
		gotoxy(23, maxj div 2); write(' LAVIRINT NIJE RESIV! ')
        end;
        if maxj < 23 then gotoxy(1, maxj+1)
        else gotoxy(1, 23);
        writeln
end.